> For clean Markdown content of this page, append .md to this URL. For the complete documentation index, see https://learning.postman.com/llms.txt. For full content including API reference and SDK examples, see https://learning.postman.com/llms-full.txt.

# Pull source changes

POST https://api.getpostman.com/environments/{environmentUid}/pulls
Content-Type: application/json

[Pulls](https://learning.postman.com/docs/collaborating-in-postman/using-version-control/forking-elements/#pull-updates-from-a-parent-element) the changes from a parent (source) environment into the forked environment.


Reference: https://learning.postman.com/api-docs/api-reference/environments/pull-environment

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Postman API
  version: 1.0.0
paths:
  /environments/{environmentUid}/pulls:
    post:
      operationId: pullEnvironment
      summary: Pull source changes
      description: >
        [Pulls](https://learning.postman.com/docs/collaborating-in-postman/using-version-control/forking-elements/#pull-updates-from-a-parent-element)
        the changes from a parent (source) environment into the forked
        environment.
      tags:
        - environments
      parameters:
        - name: environmentUid
          in: path
          description: The destination environment's unique ID.
          required: true
          schema:
            $ref: '#/components/schemas/environmentUid'
        - name: x-api-key
          in: header
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/pullEnvironmentResponse'
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/commonErrorTypeTitleDetail'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PullEnvironmentRequestUnauthorizedError'
        '404':
          description: Not Found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PullEnvironmentRequestInternalServerError'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/pullEnvironment'
servers:
  - url: https://api.getpostman.com
    description: https://api.getpostman.com
  - url: https://api.eu.postman.com
    description: https://api.eu.postman.com
components:
  schemas:
    environmentUid:
      type: string
      format: uid
      title: environmentUid
    pullEnvironment:
      type: object
      properties:
        source:
          type: string
          format: uid
          description: The source environment's unique ID to pull data from.
      required:
        - source
      title: pullEnvironment
    PullEnvironmentResponseEnvironment:
      type: object
      properties:
        uid:
          type: string
          format: uid
          description: The merged environment's unique ID.
      description: Information about the merged environment.
      title: PullEnvironmentResponseEnvironment
    pullEnvironmentResponse:
      type: object
      properties:
        environment:
          $ref: '#/components/schemas/PullEnvironmentResponseEnvironment'
          description: Information about the merged environment.
      title: pullEnvironmentResponse
    CommonErrorTypeTitleDetailDetail:
      oneOf:
        - type: string
        - type: object
          additionalProperties:
            description: Any type
      description: Information about the error.
      title: CommonErrorTypeTitleDetailDetail
    commonErrorTypeTitleDetail:
      type: object
      properties:
        type:
          type: string
          description: The type of error.
        title:
          type: string
          description: A short summary of the problem.
        detail:
          $ref: '#/components/schemas/CommonErrorTypeTitleDetailDetail'
          description: Information about the error.
      title: commonErrorTypeTitleDetail
    CommonErrorTypeTitleDetailStatusType:
      oneOf:
        - type: string
          format: uri-reference
        - type: string
      title: CommonErrorTypeTitleDetailStatusType
    commonErrorTypeTitleDetailStatus:
      type: object
      properties:
        type:
          $ref: '#/components/schemas/CommonErrorTypeTitleDetailStatusType'
        title:
          type: string
          description: A short summary of the problem.
        detail:
          type: string
          description: Information about the error.
        status:
          type: integer
          description: The error's HTTP status code.
      title: commonErrorTypeTitleDetailStatus
    CommonErrorNameMessageError:
      type: object
      properties:
        name:
          type: string
          description: The error name.
        message:
          type: string
          description: The error message.
      description: Information about the error.
      title: CommonErrorNameMessageError
    commonErrorNameMessage:
      type: object
      properties:
        error:
          $ref: '#/components/schemas/CommonErrorNameMessageError'
          description: Information about the error.
      title: commonErrorNameMessage
    PullEnvironmentRequestUnauthorizedError:
      oneOf:
        - $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        - $ref: '#/components/schemas/commonErrorNameMessage'
      title: PullEnvironmentRequestUnauthorizedError
    PullEnvironmentRequestInternalServerError:
      oneOf:
        - $ref: '#/components/schemas/commonErrorTypeTitleDetail'
        - $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        - $ref: '#/components/schemas/commonErrorNameMessage'
      title: PullEnvironmentRequestInternalServerError
  securitySchemes:
    PostmanApiKey:
      type: apiKey
      in: header
      name: x-api-key
    scimApiKey:
      type: apiKey
      in: header
      name: Authorization
      description: >-
        A valid [SCIM API
        key](https://learning.postman.com/docs/administration/scim-provisioning/scim-provisioning-overview/#generating-scim-api-key)
        for calls to SCIM endpoints.
    basicAuth:
      type: http
      scheme: basic

```

## Examples

### Successful Response



**Request**

```json
undefined
```

**Response**

```json
{
  "environment": {
    "uid": "12345678-d9c7dc8f-904e-4bba-99b5-4d490aae1957"
  }
}
```

**SDK Code**

```python Successful Response
import requests

url = "https://api.getpostman.com/environments/12345678-5daabc50-8451-43f6-922d-96b403b4f28e/pulls"

headers = {
    "x-api-key": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, headers=headers)

print(response.json())
```

```javascript Successful Response
const url = 'https://api.getpostman.com/environments/12345678-5daabc50-8451-43f6-922d-96b403b4f28e/pulls';
const options = {
  method: 'POST',
  headers: {'x-api-key': '<apiKey>', 'Content-Type': 'application/json'},
  body: undefined
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Successful Response
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.getpostman.com/environments/12345678-5daabc50-8451-43f6-922d-96b403b4f28e/pulls"

	req, _ := http.NewRequest("POST", url, nil)

	req.Header.Add("x-api-key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Successful Response
require 'uri'
require 'net/http'

url = URI("https://api.getpostman.com/environments/12345678-5daabc50-8451-43f6-922d-96b403b4f28e/pulls")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-api-key"] = '<apiKey>'
request["Content-Type"] = 'application/json'

response = http.request(request)
puts response.read_body
```

```java Successful Response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.getpostman.com/environments/12345678-5daabc50-8451-43f6-922d-96b403b4f28e/pulls")
  .header("x-api-key", "<apiKey>")
  .header("Content-Type", "application/json")
  .asString();
```

```php Successful Response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.getpostman.com/environments/12345678-5daabc50-8451-43f6-922d-96b403b4f28e/pulls', [
  'headers' => [
    'Content-Type' => 'application/json',
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp Successful Response
using RestSharp;

var client = new RestClient("https://api.getpostman.com/environments/12345678-5daabc50-8451-43f6-922d-96b403b4f28e/pulls");
var request = new RestRequest(Method.POST);
request.AddHeader("x-api-key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
IRestResponse response = client.Execute(request);
```

```swift Successful Response
import Foundation

let headers = [
  "x-api-key": "<apiKey>",
  "Content-Type": "application/json"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.getpostman.com/environments/12345678-5daabc50-8451-43f6-922d-96b403b4f28e/pulls")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Pull Source Change



**Request**

```json
{
  "source": "12345678-d9c7dc8f-904e-4bba-99b5-4d490aae1957"
}
```

**Response**

```json
{
  "environment": {
    "uid": "12345678-d9c7dc8f-904e-4bba-99b5-4d490aae1957"
  }
}
```

**SDK Code**

```python Pull Source Change
import requests

url = "https://api.getpostman.com/environments/12345678-5daabc50-8451-43f6-922d-96b403b4f28e/pulls"

payload = { "source": "12345678-d9c7dc8f-904e-4bba-99b5-4d490aae1957" }
headers = {
    "x-api-key": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Pull Source Change
const url = 'https://api.getpostman.com/environments/12345678-5daabc50-8451-43f6-922d-96b403b4f28e/pulls';
const options = {
  method: 'POST',
  headers: {'x-api-key': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"source":"12345678-d9c7dc8f-904e-4bba-99b5-4d490aae1957"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Pull Source Change
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.getpostman.com/environments/12345678-5daabc50-8451-43f6-922d-96b403b4f28e/pulls"

	payload := strings.NewReader("{\n  \"source\": \"12345678-d9c7dc8f-904e-4bba-99b5-4d490aae1957\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-api-key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Pull Source Change
require 'uri'
require 'net/http'

url = URI("https://api.getpostman.com/environments/12345678-5daabc50-8451-43f6-922d-96b403b4f28e/pulls")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-api-key"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"source\": \"12345678-d9c7dc8f-904e-4bba-99b5-4d490aae1957\"\n}"

response = http.request(request)
puts response.read_body
```

```java Pull Source Change
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.getpostman.com/environments/12345678-5daabc50-8451-43f6-922d-96b403b4f28e/pulls")
  .header("x-api-key", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"source\": \"12345678-d9c7dc8f-904e-4bba-99b5-4d490aae1957\"\n}")
  .asString();
```

```php Pull Source Change
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.getpostman.com/environments/12345678-5daabc50-8451-43f6-922d-96b403b4f28e/pulls', [
  'body' => '{
  "source": "12345678-d9c7dc8f-904e-4bba-99b5-4d490aae1957"
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp Pull Source Change
using RestSharp;

var client = new RestClient("https://api.getpostman.com/environments/12345678-5daabc50-8451-43f6-922d-96b403b4f28e/pulls");
var request = new RestRequest(Method.POST);
request.AddHeader("x-api-key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"source\": \"12345678-d9c7dc8f-904e-4bba-99b5-4d490aae1957\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Pull Source Change
import Foundation

let headers = [
  "x-api-key": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = ["source": "12345678-d9c7dc8f-904e-4bba-99b5-4d490aae1957"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.getpostman.com/environments/12345678-5daabc50-8451-43f6-922d-96b403b4f28e/pulls")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```